// _advanced expert advisor template.mq4
// Copyright  2009, TradingSystemForex.Com
// http://www.tradingsystemforex.com/

#property copyright "Copyright  2009, TradingSystemForex.Com"
#property link "http://www.tradingsystemforex.com/"

extern string comment="EA";              // comment to display in the order
extern int magic=1234;                   // magic number required if you use different settings on a same pair, same timeframe

extern string moneymanagement="Money Management";

extern double lots=0.1;                  // lots size
extern bool lotsoptimized=false;         // enable risk management
extern double risk=1;                    // risk in percentage of the account
//extern bool martingale=false;          // enable the martingale
//extern double multiplier=2.0;          // multiplier used for the martingale
extern double minlot=0.01;               // minimum lot allowed by the expert
extern double maxlot=10;                 // maximum lot allowed by the expert
extern double lotdigits=2;               // 1 for minilot, 2 for microlot
//extern bool basketpercent=false;       // enable the basket percent
//extern double profit=10;               // close all orders if a profit of 10 percents has been reached
//extern double loss=30;                 // close all orders if a loss of 30 percents has been reached

extern string ordersmanagement="Order Management";

extern bool oppositeclose=false;         // close the orders on an opposite signal
extern bool reversesignals=false;        // reverse the signals, long if short, short if long
extern int maxtrades=100;                // maximum trades allowed by the traders
extern int tradesperbar=1;               // maximum trades per bar allowed by the expert
extern bool hidesl=false;                // hide stop loss
extern bool hidetp=false;                // hide take profit
extern int stoploss=0;                   // stop loss
extern int takeprofit=0;                 // take profit
extern int trailingstart=0;              // profit in pips required to enable the trailing stop
extern int trailingstop=0;               // trailing stop
extern int trailingstep=1;               // margin allowed to the market to enable the trailing stop
extern int breakevengain=0;              // gain in pips required to enable the break even
extern int breakeven=0;                  // break even
int expiration=0;                        // expiration in minutes for pending orders
int slippage=0;                          // maximum difference in pips between signal and order
double maxspread=100;                    // maximum spread allowed by the expert

extern string entrylogics="Entry Logics";

extern bool enteroncross=false;
extern bool deadzoneexit=true;
extern bool othercolorexit=true;
extern int Sensetive=150;
extern int DeadZonePip=30;
extern int ExplosionPower=15;
extern int TrendPower=15;
extern bool usefilter=false;
extern int timeframe=240;
extern int Sensetive2=150;
extern int DeadZonePip2=30;
extern int ExplosionPower2=15;
extern int TrendPower2=15;
extern bool emailalert=false;
extern int shift=1;                      // bar in the past to take in consideration for the signal

extern string timefilter="Time Filter";

extern int gmtshift=2;                   // gmt offset of the broker
extern bool filter=false;                // enable time filter
extern int starthour=7;                  // start to trade after this hour
extern int startminute=0;                // start to trade after this minute of the starthour
extern int endhour=21;                   // stop to trade after this hour
extern int endminute=0;                  // stop to trade after this minute of the endhour
extern bool tradesunday=true;            // trade on sunday
extern bool fridayfilter=false;          // enable special time filter on friday
extern int fridayend=20;                 // stop to trade after this hour

datetime t0,t1,lastbuyopentime,lastsellopentime;
double lastbuyopenprice,lastsellopenprice,lastbuyprofit,lastsellprofit,lastprofit;
double lotsfactor=1,initiallotsfactor=1,ilots,lastbuylot,lastselllot;
double ask,bid,cb,sl,tp,pt,mt,min,max;
int i,dg,bc=-1,tpb,tps,cnt,istart,iend,total,ticket;
int lastorder,buyorderprofit,sellorderprofit,history;

datetime long;
datetime short;

int init(){
   t0=Time[0];
   t1=Time[0];
   dg=Digits;
   if(dg==3 || dg==5){pt=Point*10;mt=10;}else{pt=Point;mt=1;}
/*
   //|---------martingale initialization

   int tempfactor;
   total=OrdersTotal();
   if(tempfactor==0 && total>0){
      for(i=0;i<total;i++){
         if(OrderSelect(i,SELECT_BY_POS)){
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
               tempfactor=NormalizeDouble(OrderLots()/lots,1+(MarketInfo(Symbol(),MODE_MINLOT)==0.01));
               break;
            }
         }
      }
   }
   int histotal=OrdersHistoryTotal();
   if(tempfactor==0&&histotal>0){
      for(cnt=0;cnt<histotal;cnt++){
         if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)){
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
               tempfactor=NormalizeDouble(OrderLots()/lots,1+(MarketInfo(Symbol(),MODE_MINLOT)==0.01));
               break;
            }
         }
      }
   }
   if(tempfactor>0)
   lotsfactor=tempfactor;
*/
   return(0);
}

int start(){
/*
   GlobalVariableSet("vGrafBalance",AccountBalance());
   GlobalVariableSet("vGrafEquity",AccountEquity());
*/
   ask=MarketInfo(Symbol(),MODE_ASK);
   bid=MarketInfo(Symbol(),MODE_BID);

   if(breakevengain>0)movebreakeven(breakevengain,breakeven);
   if(trailingstop>0)movetrailingstop(trailingstart,trailingstop);
   //if(basketpercent)closebasketpercent(profit,loss);
/*
   lastbuylot=0;
   lastselllot=0;
   lastorder=0;

   history=OrdersHistoryTotal();
   if(history>0){
      for(i=0;i<history;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            lastprofit=OrderProfit();
            if(OrderType()==OP_BUY){
               lastbuyprofit=OrderProfit();
               lastbuylot=OrderLots();
               lastorder=1;
            }
            if(OrderType()==OP_SELL){
               lastsellprofit=OrderProfit();
               lastselllot=OrderLots();
               lastorder=2;
            }
         }
      }
   }

   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderCloseTime()==0){
            if(OrderType()==OP_BUY){
               lastbuyopentime=OrderOpenTime();
               lastbuyopenprice=OrderOpenPrice();
               buyorderprofit=OrderProfit();
            }
            if(OrderType()==OP_SELL){
               lastsellopentime=OrderOpenTime();
               lastsellopenprice=OrderOpenPrice();
               sellorderprofit=OrderProfit();
            }
         }
      }
   }
*/
   double wag=iCustom(NULL,0,"Waddah_Attar_Explosion",Sensetive,DeadZonePip,ExplosionPower,TrendPower,true,6,true,true,true,true,0,shift);
   double war=iCustom(NULL,0,"Waddah_Attar_Explosion",Sensetive,DeadZonePip,ExplosionPower,TrendPower,true,6,true,true,true,true,1,shift);
   double way=iCustom(NULL,0,"Waddah_Attar_Explosion",Sensetive,DeadZonePip,ExplosionPower,TrendPower,true,6,true,true,true,true,2,shift);
   
   if(enteroncross){
      double waga=iCustom(NULL,0,"Waddah_Attar_Explosion",Sensetive,DeadZonePip,ExplosionPower,TrendPower,true,6,true,true,true,true,0,shift+1);
      double wara=iCustom(NULL,0,"Waddah_Attar_Explosion",Sensetive,DeadZonePip,ExplosionPower,TrendPower,true,6,true,true,true,true,1,shift+1);
      double waya=iCustom(NULL,0,"Waddah_Attar_Explosion",Sensetive,DeadZonePip,ExplosionPower,TrendPower,true,6,true,true,true,true,2,shift+1);
   }
   if(usefilter){
      double wagtf=iCustom(NULL,timeframe,"Waddah_Attar_Explosion",Sensetive2,DeadZonePip2,ExplosionPower2,TrendPower2,true,6,true,true,true,true,0,shift);
      double wartf=iCustom(NULL,timeframe,"Waddah_Attar_Explosion",Sensetive2,DeadZonePip2,ExplosionPower2,TrendPower2,true,6,true,true,true,true,1,shift);
      double waytf=iCustom(NULL,timeframe,"Waddah_Attar_Explosion",Sensetive2,DeadZonePip2,ExplosionPower2,TrendPower2,true,6,true,true,true,true,2,shift);
   }
   
   int waddahsignal=0;
   if(((enteroncross==false && wag>0 && wag>way) || (enteroncross && wag>0 && wag>way && !(waga>0 && waga>waya))) && (usefilter==false || (usefilter && wagtf>0 && wagtf>waytf)))waddahsignal=1;
   if(((enteroncross==false && war>0 && war>way) || (enteroncross && war>0 && war>way && !(wara>0 && wara>waya))) && (usefilter==false || (usefilter && wartf>0 && wartf>waytf)))waddahsignal=2;

   if(tradesperbar==1 && (((TimeCurrent()-lastbuyopentime)<Period()) || ((TimeCurrent()-lastsellopentime)<Period()))){tpb=1;tps=1;}

   bool buy=false;bool sell=false;
   if(waddahsignal==1){if(reversesignals)sell=true;else buy=true;if(emailalert && long!=Time[0]){SendMail("Signal for LONG",Symbol());long=Time[0];}}
   if(waddahsignal==2){if(reversesignals)buy=true;else sell=true;if(emailalert && short!=Time[0]){SendMail("Signal for SHORT",Symbol());short=Time[0];}}

   if(bc!=Bars){tpb=0;tps=0;bc=Bars;}
   //Comment("\ncbuy = "+DoubleToStr(count(OP_BUY),0),"\ncsell = "+DoubleToStr(count(OP_SELL),0));

   if((oppositeclose && sell) || (deadzoneexit && war<way && wag<way) || (othercolorexit && war>0))closebuy();
   if((oppositeclose && buy) || (deadzoneexit && war<way && wag<way) || (othercolorexit && wag>0))closesell();

   if(hidesl){
      for(i=0;i<OrdersTotal();i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(stoploss>0 && bid<(OrderOpenPrice()-stoploss*pt))closebuy();
         if(stoploss>0 && ask>(OrderOpenPrice()+stoploss*pt))closesell();
      }
   }
   if(hidetp){
      for(i=0;i<OrdersTotal();i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(takeprofit>0 && bid>(OrderOpenPrice()+takeprofit*pt))closebuy();
         if(takeprofit>0 && ask<(OrderOpenPrice()-takeprofit*pt))closesell();
      }
   }
   
   if((filter && ((Hour()==starthour+gmtshift && Minute()<startminute) || (Hour()<(starthour+gmtshift) && Hour()>(endhour+gmtshift))
   || ((Hour()==endhour+gmtshift && Minute()>endminute)))) || (fridayfilter && DayOfWeek()==5 && !(Hour()<(fridayend+gmtshift)))
   || (tradesunday==false && DayOfWeek()==0))return(0);
   
   if((ask-bid)>maxspread*pt)return(0);

   if(lotsoptimized /*&& (martingale==false || (martingale && lastprofit>=0))*/)lots=NormalizeDouble((AccountBalance()/1000)*minlot*risk,lotdigits);

   int expire=0;
   if(expiration>0)expire=TimeCurrent()+(expiration*60)-5;

   if((count(OP_BUY)+count(OP_SELL))<maxtrades){  
      if(buy && tpb<tradesperbar && IsTradeAllowed()){
         while(IsTradeContextBusy())Sleep(3000);
         /*if(martingale)ilots=NormalizeDouble(lots*martingalefactor(),2);else*/ ilots=lots;
         ticket=open(OP_BUY,ilots,ask,stoploss,takeprofit,expire,Blue);
         if(ticket<=0){/*Print("Error Occured : "+errordescription(GetLastError()));*/}else tpb++;
      }
      if(sell && tps<tradesperbar && IsTradeAllowed()){
         while(IsTradeContextBusy())Sleep(3000);
         /*if(martingale)ilots=NormalizeDouble(lots*martingalefactor(),2);else*/ ilots=lots;
         ticket=open(OP_SELL,ilots,bid,stoploss,takeprofit,expire,Red);
         if(ticket<=0){/*Print("Error Occured : "+errordescription(GetLastError()));*/}else tps++;
      }
   }
   
   return(0);
}

//|---------open

int open(int type,double lots,double price,int stoploss,int takeprofit,int expire,color clr){
   ask=MarketInfo(Symbol(),MODE_ASK);
   bid=MarketInfo(Symbol(),MODE_BID);
   if(ilots<minlot)ilots=minlot;
   if(ilots>maxlot)ilots=maxlot;
   if(type==OP_BUY){
      if(hidesl==false&&stoploss>0){sl=price-stoploss*pt;}else{sl=0;}
      if(hidetp==false&&takeprofit>0){tp=price+takeprofit*pt;}else{tp=0;}
   }
   if(type==OP_SELL){
      if(hidesl==false&&stoploss>0){sl=price+stoploss*pt;}else{sl=0;}
      if(hidetp==false&&takeprofit>0){tp=price-takeprofit*pt;}else{tp=0;}
   }
   RefreshRates();
   ticket=OrderSend(Symbol(),type,lots,price,slippage*mt,sl,tp,comment+". Magic: "+DoubleToStr(magic,0),magic,expire,clr);
   //if(type==OP_BUY && ticket>0){Print("Order opened : "+Symbol()+" Buy @ "+ask+" SL @ "+sl+" TP @"+tp+" ticket ="+ticket);}
   //if(type==OP_SELL && ticket>0){Print("Order opened : "+Symbol()+" Sell @ "+bid+" SL @ "+sl+" TP @"+tp+" ticket ="+ticket);}
   return(ticket);
}

//|---------counter

int count(int type){
   cnt=0;
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderType()==type && OrderMagicNumber()==magic)cnt++;
      }
      return(cnt);
   }
}

//|---------close

void closebuy(){
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUY){
            OrderClose(OrderTicket(),OrderLots(),bid,slippage*mt);
         }
      }
   }
}

void closesell(){
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELL){
            OrderClose(OrderTicket(),OrderLots(),ask,slippage*mt);
         }
      }
   }
}
/*
//|---------delete

void deletebuypending(){
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUYSTOP){
            OrderDelete(OrderTicket());
         } 
      }
   }
}

void deletesellpending(){
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELLSTOP){
          OrderDelete(OrderTicket());
        }   
      }
   }
}
*/
//|---------breakeven

void movebreakeven(int breakevengain,int breakeven){
   ask=MarketInfo(Symbol(),MODE_ASK);
   bid=MarketInfo(Symbol(),MODE_BID);
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble((bid-OrderOpenPrice()),dg)>=NormalizeDouble(breakevengain*pt,dg)){
                  if((NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),dg)<NormalizeDouble(breakeven*pt,dg))||OrderStopLoss()==0){
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+breakeven*pt,dg),OrderTakeProfit(),0,Blue);
                     return(0);
                  }
               }
            }
            else{
               if(NormalizeDouble((OrderOpenPrice()-ask),dg)>=NormalizeDouble(breakevengain*pt,dg)){
                  if((NormalizeDouble((OrderOpenPrice()-OrderStopLoss()),dg)<NormalizeDouble(breakeven*pt,dg))||OrderStopLoss()==0){
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-breakeven*pt,dg),OrderTakeProfit(),0,Red);
                     return(0);
                  }
               }
            }
         }
      }
   }
}

//|---------trailingstop

void movetrailingstop(int trailingstart,int trailingstop){
   ask=MarketInfo(Symbol(),MODE_ASK);
   bid=MarketInfo(Symbol(),MODE_BID);
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble(ask,dg)>NormalizeDouble(OrderOpenPrice()+trailingstart*pt,dg)
               && (NormalizeDouble(OrderStopLoss(),dg)<NormalizeDouble(bid-(trailingstop+trailingstep)*pt,dg))||(OrderStopLoss()==0)){
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(bid-trailingstop*pt,dg),OrderTakeProfit(),0,Blue);
                  return(0);
               }
            }
            else{
               if(NormalizeDouble(bid,dg)<NormalizeDouble(OrderOpenPrice()-trailingstart*pt,dg)
               && (NormalizeDouble(OrderStopLoss(),dg)>(NormalizeDouble(ask+(trailingstop+trailingstep)*pt,dg)))||(OrderStopLoss()==0)){                 
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(ask+trailingstop*pt,dg),OrderTakeProfit(),0,Red);
                  return(0);
               }
            }
         }
      }
   }
}
/*
//|---------basket

void closebasketpercent(double profit,double loss){
   double ipf=profit*(0.01*AccountBalance());
   double ilo=loss*(0.01*AccountBalance());
   cb=AccountEquity()-AccountBalance();
   if(cb>=ipf||cb<=(ilo*(-1))){
      closebuy();
      closesell();
      deletebuypending();
      deletesellpending();
      return(0);
   }
}
*//*
//|---------martingale

int martingalefactor(){
   history=OrdersHistoryTotal();
   if(history>0){
      for(i=0;i<history;i++){
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
               if(OrderProfit()<0){
                  lotsfactor=lotsfactor*multiplier;
                  return(lotsfactor);
               }
               else{
                  lotsfactor=initiallotsfactor;
                  if(lotsfactor<=0){
                     lotsfactor=1;
                  }
                  return(lotsfactor);
               }
            }
         }
      }
   }
   return(lotsfactor);
}
*//*
//|---------error

string errordescription(int code){
   string error;
   switch(code){
      case 0:
      case 1:error="no error";break;
      case 2:error="common error";break;
      case 3:error="invalid trade parameters";break;
      case 4:error="trade server is busy";break;
      case 5:error="old version of the client terminal";break;
      case 6:error="no connection with trade server";break;
      case 7:error="not enough rights";break;
      case 8:error="too frequent requests";break;
      case 9:error="malfunctional trade operation";break;
      case 64:error="account disabled";break;
      case 65:error="invalid account";break;
      case 128:error="trade timeout";break;
      case 129:error="invalid price";break;
      case 130:error="invalid stops";break;
      case 131:error="invalid trade volume";break;
      case 132:error="market is closed";break;
      case 133:error="trade is disabled";break;
      case 134:error="not enough money";break;
      case 135:error="price changed";break;
      case 136:error="off quotes";break;
      case 137:error="broker is busy";break;
      case 138:error="requote";break;
      case 139:error="order is locked";break;
      case 140:error="long positions only allowed";break;
      case 141:error="too many requests";break;
      case 145:error="modification denied because order too close to market";break;
      case 146:error="trade context is busy";break;
      case 4000:error="no error";break;
      case 4001:error="wrong function pointer";break;
      case 4002:error="array index is out of range";break;
      case 4003:error="no memory for function call stack";break;
      case 4004:error="recursive stack overflow";break;
      case 4005:error="not enough stack for parameter";break;
      case 4006:error="no memory for parameter string";break;
      case 4007:error="no memory for temp string";break;
      case 4008:error="not initialized string";break;
      case 4009:error="not initialized string in array";break;
      case 4010:error="no memory for array\' string";break;
      case 4011:error="too long string";break;
      case 4012:error="remainder from zero divide";break;
      case 4013:error="zero divide";break;
      case 4014:error="unknown command";break;
      case 4015:error="wrong jump (never generated error)";break;
      case 4016:error="not initialized array";break;
      case 4017:error="dll calls are not allowed";break;
      case 4018:error="cannot load library";break;
      case 4019:error="cannot call function";break;
      case 4020:error="expert function calls are not allowed";break;
      case 4021:error="not enough memory for temp string returned from function";break;
      case 4022:error="system is busy (never generated error)";break;
      case 4050:error="invalid function parameters count";break;
      case 4051:error="invalid function parameter value";break;
      case 4052:error="string function internal error";break;
      case 4053:error="some array error";break;
      case 4054:error="incorrect series array using";break;
      case 4055:error="custom indicator error";break;
      case 4056:error="arrays are incompatible";break;
      case 4057:error="global variables processing error";break;
      case 4058:error="global variable not found";break;
      case 4059:error="function is not allowed in testing mode";break;
      case 4060:error="function is not confirmed";break;
      case 4061:error="send mail error";break;
      case 4062:error="string parameter expected";break;
      case 4063:error="integer parameter expected";break;
      case 4064:error="double parameter expected";break;
      case 4065:error="array as parameter expected";break;
      case 4066:error="requested history data in update state";break;
      case 4099:error="end of file";break;
      case 4100:error="some file error";break;
      case 4101:error="wrong file name";break;
      case 4102:error="too many opened files";break;
      case 4103:error="cannot open file";break;
      case 4104:error="incompatible access to a file";break;
      case 4105:error="no order selected";break;
      case 4106:error="unknown symbol";break;
      case 4107:error="invalid price parameter for trade function";break;
      case 4108:error="invalid ticket";break;
      case 4109:error="trade is not allowed";break;
      case 4110:error="longs are not allowed";break;
      case 4111:error="shorts are not allowed";break;
      case 4200:error="object is already exist";break;
      case 4201:error="unknown object property";break;
      case 4202:error="object is not exist";break;
      case 4203:error="unknown object type";break;
      case 4204:error="no object name";break;
      case 4205:error="object coordinates error";break;
      case 4206:error="no specified subwindow";break;
      default:error="unknown error";
   }
   return(error);
}
*/